from PyQt4.QtGui import *
from PyQt4.QtCore import *

import sys
from time import sleep

class mywidget(QWidget):
    def __init__(self):
        super(QWidget, self).__init__()
        self.gobutton = QPushButton("Go")
        self.logwindow = QTextEdit()
        self.setLayout(QVBoxLayout())
        self.layout().addWidget(self.gobutton)
        self.layout().addWidget(self.logwindow)

        self.processor = processor()
        self.connect(self.processor, SIGNAL("statusChanged(str)"), self.logwindow.append)
        self.connect(self.gobutton, SIGNAL("clicked()"), self.processor.process)

         
class processor(QObject):
    def __init__(self):
        super(QObject, self).__init__()

    def process(self):
        self.emit (SIGNAL("statusChanged(str)"), "Starting A\n")
        #simulating some lengthy process A
        sleep(10)
        self.emit (SIGNAL("statusChanged(str)"), "A done, starting B\n")
        #simulating some lengthy process B
        sleep(10)
        self.emit (SIGNAL("statusChanged(str)"), "B done. Finished\n")


if __name__ == '__main__':
    app = QApplication(sys.argv)
    w = mywidget()
    w.show()
    app.exec_()
